<?php
# This file is distributed under GNU GPLv1 and further versions.
# This file was written by Zdenek Styblik
# This file is part of weathermap4rrd-ng
#
# Zdenek Styblik
# e-mail: zdenek <dot> styblik <at> gmail <dot> com
# jabber: stybla <at> danysek <dot> cz
#
# Last update: 2007-11-22
#

class formglobal extends defaultLib {
	public $auto_index;
	public $scriptname;
	public $settings;

	function __construct() {
		$this->auto_index = -1;
		$this->settings = new StdClass;
		$settings = $this->settings;
		$settings->config = new StdClass;
		$settings->xmlobject = new StdClass;
		$this->scriptname = $this->getScriptname();
	}

	function __destruct() {
		$this->settings;
		$this->auto_index;
	}

	public function init() {
		if (isset($_GET['action'])) {
			$action = $this->stripMe($_GET['action']);
		} else {
			$action = "foo";
		}
		switch ($action) {
			case 'edit':
				$this->showGlobalForm();
				break;
			case 'update':
				$this->updateGlobal();
				break;
			default:
				$this->showGlobalForm();
				break;
		}
	}

	private function showGlobalForm() {
		$config = $this->settings->config;
		$path = $this->getPath();
		require_once "{$path}lib/configfile.php";
		$configfile = new config_file();
		if ($configfile->readconfig() == false) {
			# there is no config file, so let's give user
			# chance to create one :)
			$this->settings->layout = "form_global.xsl";
		} else {
			# get config vars from config file
			$config = $configfile->getConfig();
			$xml = $this->settings->xmlobject;
			if (isset($config->htmlfile))
				$xml->htmlfile = $config->htmlfile;
			if (isset($config->outputfile))
				$xml->outputfile = $config->outputfile;
			if (isset($config->width))
				$xml->width = $config->width;
			if (isset($config->height))
				$xml->height = $config->height;
			if (isset($config->refresh))
				$xml->refresh = $config->refresh;
			# font
			if (!isset($config->font))
				$config->font = 3;
			for ($a = 0; $a < 6; $a++) {
				$xml->font->entry[$a] = new StdClass;
				$xml->font->entry[$a]->text = "{$a}";
				$xml->font->entry[$a]->size = "{$a}";
				if ($a == $config->font) {
					$xml->font->entry[$a]->isselected = "yes";
				}
			}
			# legend object
			$xml->legendstyle->entry[0] = new StdClass;
			$xml->legendstyle->entry[0]->style = "original";
			$xml->legendstyle->entry[1] = new StdClass;
			$xml->legendstyle->entry[1]->style = "line";
			if (isset($config->legend->legendstyle) && $config->legend->legendstyle == 'line') {
				$xml->legendstyle->entry[1]->isselected = "yes";
			} else {
				$xml->legendstyle->entry[0]->isselected = "yes";
			}
			# title object
			$xml->title = $config->title;
			# background
			if (isset($config->background) && file_exists("{$path}background/" . $config->background)) {
				$match = $config->background;
			} else {
				$match = "";
			}
			$xml->background = new StdClass;
			$this->auto_index++;
			$xml->background->entry[$this->auto_index] = new StdClass;
			$xml->background->entry[$this->auto_index]->name = "none";
			if (is_dir("{$path}background/")) {
				$ls = scandir("{$path}background/");
				foreach ($ls as $k=>$v) {
					if (strstr($v, '.png')) {
						$this->auto_index++;
						$xml->background->entry[$this->auto_index] = new StdClass;
						$xml->background->entry[$this->auto_index]->name = $v;
						if ($match == $v) {
							$xml->background->entry[$this->auto_index]->isselected = "yes";
							$xml->bgimgsrc = "background/" . $v;
						}
					}
				} // foreach $ls
			} // is_dir
			# Availability checks
			if (isset($config->ipcheck) && $config->ipcheck == 1) {
				$xml->ipcheck = "yes";
			}
			# set layout
			$this->settings->layout = "form_global.xsl";
			# set formaction
			$xml->formaction = "{$this->scriptname}?module=formglobal&#38;action=update";
			$xml->updatelink = "javascript:document.formglobal.submit()";
			$xml->cancellink = "{$this->scriptname}?module=editor";
		}
	}

	private function updateGlobal() {
		$config = $this->settings->config;
		$path = $this->getPath();
		require_once "{$path}lib/configfile.php";
		$configfile = new config_file();
		if ($configfile->readconfig() == false) {
			# try to create config
		} else {
			# replace values in old config
			$config = $this->settings->config;
			$config = $configfile->getConfig();
			# fixme - possible security hole;
			# however it'd require more external libs
			# and that's probably unwanted
			#
			# image background
			if (isset($_POST['background']) && file_exists("{$path}background/{$_POST['background']}") && preg_match('/[\.png]$/', $_POST['background']) !== false) {
				$config->background = $this->stripMe($_POST['background']);
			} else {
				unset($config->background);
			}
			# map refresh
			if (isset($_POST['refresh']) && is_numeric($_POST['refresh'])) {
				$config->refresh = $this->stripMe($_POST['refresh']);
			}
			# image map width
			if (isset($_POST['width']) && is_numeric($_POST['width'])) {
				$config->width = $this->stripMe($_POST['width']);
			}
			# image map height
			if (isset($_POST['height']) && is_numeric($_POST['height'])) {
				$config->height = $this->stripMe($_POST['height']);
			}
			# note: should we check for file/access
			if (isset($_POST['htmlfile'])) {
				$config->htmlfile = $this->stripMe($_POST['htmlfile']);
			}
			# font size 0-5
			if (isset($_POST['font']) && is_numeric($_POST['font'])) {
				if ($_POST['font'] >= 0 && $_POST['font'] <= 5) {
					$config->font = $this->stripMe($_POST['font']);
				}
			}
			# title text
			# background:rgb(200,200,255) - fg
			# background:rgb(255,200,0) - bg
			if (isset($_POST['titletext'])) {
				$config->title->text = $this->stripMe($_POST['titletext']);
			}
			# title foreground colors(RGB)
			if (isset($_POST['titleforeground_red']) && is_numeric($_POST['titleforeground_red'])) {
				if ($_POST['titleforeground_red'] >= 0 && $_POST['titleforeground_red'] <= 255) {
					$config->title->fg->r = $this->stripMe($_POST['titleforeground_red']);
				}
			}
			if (isset($_POST['titleforeground_green']) && is_numeric($_POST['titleforeground_green'])) {
				if ($_POST['titleforeground_green'] >= 0 && $_POST['titleforeground_green'] <= 255) {
					$config->title->fg->g = $this->stripMe($_POST['titleforeground_green']);
				}
			}
			if (isset($_POST['titleforeground_blue']) && is_numeric($_POST['titleforeground_blue'])) {
				if ($_POST['titleforeground_blue'] >= 0 && $_POST['titleforeground_blue'] <= 255) {
					$config->title->fg->b = $this->stripMe($_POST['titleforeground_blue']);
				}
			}
			# title background colors(RGB)
			if (isset($_POST['titlebackground_red']) && is_numeric($_POST['titlebackground_red'])) {
				if ($_POST['titlebackground_red'] >= 0 && $_POST['titlebackground_red'] <= 255) {
					$config->title->bg->r = $this->stripMe($_POST['titlebackground_red']);
				}
			}
			if (isset($_POST['titlebackground_green']) && is_numeric($_POST['titlebackground_green'])) {
				if ($_POST['titlebackground_green'] >= 0 && $_POST['titlebackground_green'] <= 255) {
					$config->title->bg->g = $this->stripMe($_POST['titlebackground_green']);
				}
			}
			if (isset($_POST['titlebackground_blue']) && is_numeric($_POST['titlebackground_blue'])) {
				if ($_POST['titlebackground_blue'] >= 0 && $_POST['titlebackground_blue'] <= 255) {
					$config->title->bg->b = $this->stripMe($_POST['titlebackground_blue']);
				}
			}
			# output file
			if (isset($_POST['outputfile'])) {
				$config->outputfile = $this->stripMe($_POST['outputfile']);
			}
			# legend style
			if (isset($_POST['legendstyle'])) {
				if ($_POST['legendstyle'] == 'line') {
					$config->legend->legendstyle = 'line';
				} else {
					$config->legend->legendstyle = 'original';
				}
			}
			# availability checks
			if (isset($_POST['ipcheck']) && $_POST['ipcheck'] == 'on') {
				$config->ipcheck = 1;
			}	else {
				if (isset($config->ipcheck)) {
					unset($config->ipcheck);
				}
			}
			$cfg = "{$path}weathermap.xml";
			copy ($cfg, $cfg . ".1");
			$xml = "<root>\n";
			$xml.= $this->objToXml($config);
			$xml.= "</root>";
			$configfile->writeconfig($xml);
		}
		header("Location: {$this->scriptname}?module=editor");
		exit();
	}
}
?>
